- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Friends

# MDagPathArray Class Reference

# OpenMaya - API module for common classes

Search for all occurrences

## Detailed Description

Indexable Array of DAG Paths.

Provides methods for manipulating arrays of DAG Paths.

Arrays of DAG Paths are useful for storing and manipluating multiple Paths to a particular DAG Node. The DAG Path method MDagPath::getAllPathsTo() and DAG Node Function Set method MFnDagNode::getAllPaths() implicitly return an array of DAG Paths.

These arrays may also be used to manage Paths for a number of different Nodes.

DAG Path arrays are used in conjunction with DAG Paths (MDagPath) and individual elements of the arrays can be parameters to some methods of the DAG Node Function Set (MFnDagNode).

Use this DAG Path Array Class to create and manipulate arrays of DAG Paths, for either a particular DAG Node or a number of different DAG Nodes.

The length of the array adjusts automatically.

Examples:

  exportSkinClusterDataCmd.cpp, instancerListCmd.cpp, listLightLinksCmd.cpp, maTranslator.cpp, meshMapUtils.cpp, meshMapUtils.h, meshRemapCmd.cpp, meshRemapTool.h, meshReorderCmd.cpp, meshReorderTool.h, narrowPolyViewer.cpp, narrowPolyViewer.h, and narrowPolyViewerCmd.h.

`#include <MDagPathArray.h>`

List of all members.

## Public Member Functions
| MDagPathArray ()
| Class Constructor.
| MDagPathArray (const MDagPathArray &other)
| Copy Constructor.
| MDagPathArray (unsigned int initializeSize, const MDagPath &initialValue)
| Create a new array of MDagPaths of a specified size and initialize all the elements with the given initial value.
| ~MDagPathArray ()
| Class Destructor.
const MDagPath & | operator[] (unsigned int index) const
| Retrieves the read-only DAG Path which is at the specified index in the array.
MDagPathArray & | operator= (const MDagPathArray &other)
| Assignment operator copies all of the elements of the other array into this one.
MStatus | set (const MDagPath &element, unsigned int index)
| Sets an element of the array to the given DAG path.
MStatus | setLength (unsigned int length)
| Set the length of the array.
unsigned int | length () const
| Determines the number of elements in the array.
MStatus | remove (unsigned int index)
| Removes the DAG Path which is at the specified index in the array.
MStatus | insert (const MDagPath &element, unsigned int index)
| Inserts the given DAG Path at the specified index in the array.
MStatus | append (const MDagPath &element)
| Appends the given DAG Path to the end of the array.
MStatus | copy (const MDagPathArray &source)
| Copy the contents of the source array to this array.
MStatus | clear ()
| Clears this array.
void | setSizeIncrement (unsigned int newIncrement)
| Set the size by which the array will be expanded whenever expansion is necessary.
unsigned int | sizeIncrement () const
| Return the size by which the array will be expanded whenever expansion is necessary.
MDagPath & | operator[] (unsigned int index)
| Retrieves the DAG Path which is at the specified index in the array.
## Static Public Member Functions
static const char * | className ()
| Returns the name of this class.
## Friends
OPENMAYA_EXPORT std::ostream & | operator<< (std::ostream &os, const MDagPathArray &array)
| NO SCRIPT SUPPORT.

## Constructor & Destructor Documentation

MDagPathArray | ( |  | ) |

Class Constructor.

Creates a DAG Path Array

MDagPathArray | ( | const MDagPathArray & | other | ) |

Copy Constructor.

Parameters:

  [in] | other | the array with which to initialize this instance

MDagPathArray | ( | unsigned int | initialSize,
|  | const MDagPath & | initialValue
| ) |  |

Create a new array of MDagPaths of a specified size and initialize all the elements with the given initial value.

Parameters:

  [in] | initialSize | the initial size of the array
  [in] | initialValue | the initial value of each element

~MDagPathArray | ( |  | ) |

Class Destructor.

No additional action.

## Member Function Documentation

const MDagPath & operator[] | ( | unsigned int | index | ) | const

Retrieves the read-only DAG Path which is at the specified index in the array.

Parameters:

  [in] | index | Zero-based index to the array

Returns:
  DAG Path at the specified index

MDagPathArray & operator= | ( | const MDagPathArray & | other | ) |

Assignment operator copies all of the elements of the other array into this one.

If the other array was returned as a reference to internal data then this array will also become a reference rather than doing a full copy.

Parameters:

  [in] | other | the array being copied

Returns:
  A reference to this array

MStatus set | ( | const MDagPath & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Sets an element of the array to the given DAG path.

Parameters:

  [in] | element | New DAG path to be set on the indicated element
  [in] | index | Zero-based index to the array

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus setLength | ( | unsigned int | length | ) |

Search for all occurrences

Set the length of the array.

This will grow and shrink the array as desired. Elements that are grown have uninitialized values, while those which are shrunk will lose the data contained in the deleted elements (ie. it will release the memory).

Parameters:

  [in] | length | the new size of the array

Examples:
  meshRemapCmd.cpp, and meshReorderCmd.cpp.

unsigned int length | ( |  | ) | const

Search for all occurrences

Determines the number of elements in the array.

Returns:
  Number of elements in the array

Examples:
  listLightLinksCmd.cpp, meshMapUtils.cpp, and narrowPolyViewer.cpp.

MStatus remove | ( | unsigned int | index | ) |

Search for all occurrences

Removes the DAG Path which is at the specified index in the array.

Parameters:

  [in] | index | Zero-based index to the array

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus insert | ( | const MDagPath & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Inserts the given DAG Path at the specified index in the array.

Parameters:

  [in] | element | DAG Path to be inserted
  [in] | index | Zero-based index to the array

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus append | ( | const MDagPath & | element | ) |

Search for all occurrences

Appends the given DAG Path to the end of the array.

Parameters:

  [in] | element | DAG Path to be appended

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

Examples:
  narrowPolyViewer.cpp.

MStatus copy | ( | const MDagPathArray & | source | ) |

Search for all occurrences

Copy the contents of the source array to this array.

Parameters:

  [in] | source | array to copy from

Returns:
  MS::kSuccess if the copy was successful and MS::kFailure otherwise

MStatus clear | ( |  | ) |

Search for all occurrences

Clears this array.

Length of the array becomes zero.

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

Examples:
  listLightLinksCmd.cpp, and narrowPolyViewer.cpp.

void setSizeIncrement | ( | unsigned int | newIncrement | ) |

Search for all occurrences

Set the size by which the array will be expanded whenever expansion is necessary.

Parameters:

  [in] | newIncrement | the new increment

unsigned int sizeIncrement | ( |  | ) | const

Search for all occurrences

Return the size by which the array will be expanded whenever expansion is necessary.

Returns:
  The size increment.

MDagPath & operator[] | ( | unsigned int | index | ) |

Retrieves the DAG Path which is at the specified index in the array.

Parameters:

  [in] | index | Zero-based index to the array

Returns:
  DAG Path at the specified index

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  The name of this class.

## Friends And Related Function Documentation

OPENMAYA_EXPORT std::ostream& operator<< | ( | std::ostream & | os,
|  | const MDagPathArray & | array
| ) |  | `[friend]`

NO SCRIPT SUPPORT.

The format used is [fullPathName, fullPathName, fullPathName, ... fullPathName].

Parameters:

  [in] | os | the ostream to print to
  [in] | array | the MDagPathArray whose value is to be printed

Returns:
  The ostream reference, s, provided as the first parameter.

MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray
MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray MDagPathArray